routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

 // Route::get('/','HomeController@home');
  Route::get('/',function(){
 	 return view('hasen');
  });

Route::match(['get','post'],'/LogIn','LoginController@LoginControl')->name('Login')->middleware('throttle:3,1');
Route::get('home','HomeController@home')->name('Home');

/* Routes Accessible By Registerar */

Route::prefix('Registerars')->name('Registerar.')->middleware('Registerar')->group(function(){

	Route::get('{id}/LogOut','Registerar\LogOutController@LOgOut')->name('LogOut');
	Route::get('{id}/Profile','Registerar\ProfileController@ShowProfile')->name('Profile');
	Route::get('/Add_Patient','Registerar\PatientController@Add')->name('Add_Patient');
	Route::get('{id}/Search_Patient','Registerar\PatientController@Search_Patient')->name('Search_Patient');
	Route::get('{id1}/Send_Patient/{id2}','Registerar\PatientController@Send_Patient')->name('Send_Patient');
	Route::get('{id}/ChangeProfile','Common\ChangeProfileController@Index')->name('ChangeProfile');
	Route::post('{id}/UpdateProfile','Common\ChangeProfileController@UpdateProfile')->name('UpdateProfile');
	Route::get('{id}/UpdateImage','Common\ChangeProfileController@Show_Update_plate')->name('UpdateImage');
	Route::post('{id}/ImageUpdated','Common\ChangeProfileController@ImageUpdated')->name('ImageUpdated');
	Route::get('{id}/Show_Password_Template','Common\ChangeProfileController@Show_Password_Template')->name('Show_Password_Template');
	Route::post('{id}/ChangePassword','Common\ChangeProfileController@ChangePassword')->name('ChangePassword');
	
});

/* Routes Accessible By Doctors */
Route::prefix('Doctors')->name('Doctors.')->middleware('Doctors')->group(function(){
	Route::get('{id}/LogOut','Doctors\LogOutController@LogOut')->name('LogOut');

	Route::get('{id}/Profile','Doctors\ProfileController@ShowProfile')->name('Profile');

	Route::get('/SelectRoom','Common\RoomController@SelectRoom')->name('SelectRoom');

	Route::get('/Show_Patient_List','Doctors\PatientTaskController@Show_Patient_List')->name('Show_Patient_List');

	Route::get('{id1}/View_Patient_Data/{id2}','Doctors\PatientTaskController@View_Patient_Data')->name('View_Patient_Data');
	Route::get('{username}/Add_Patient_result/{clinic_id}','Doctors\PatientTaskController@Add_Patient_result')->name('Add_Patient_result');
	Route::post('{username}/Submit_Result/{clinic_id}','Doctors\PatientTaskController@Submit_Result')->name('Submit_Result');

	Route::get('{username}/Send_To_Phermacy/{clinic_id}','Doctors\PatientTaskController@Send_To_Phermacy')->name('Send_To_Phermacy');
	Route::get('Show_Medicine_Paper/{clinic_id}','Doctors\PatientTaskController@Show_Medicine_Paper')->name('Show_Medicine_Paper');
	Route::get('Labratory_Paper/{clinic_id}','Doctors\PatientTaskController@Labratory_Paper')->name('Labratory_Paper');
	Route::get('{doctor_id}/Send_To_Labratory/{clinic_id}','Doctors\PatientTaskController@Send_To_Labratory')->name('Send_To_Labratory');
	Route::get('Finish_Result/{clinic_id}','Doctors\PatientTaskController@Finish_Result')->name('Finish_Result');
	




});

/* Route Accessible By Phermacy */

Route::prefix('Phermacy')->name('Phermacy.')->middleware('Phermacy')->group(function(){
	Route::get('{id}/LogOut','Phermacy\LogOutController@LogOut')->name('LogOut');
	Route::get('{id}/Profile','Phermacy\ProfileController@ShowProfile')->name('Profile');
	Route::get('/SelectRoom','Common\RoomController@SelectRoom')->name('SelectRoom');
	Route::get('Show_Patient_List','Phermacy\PatientTaskController@Show_Patient_List')->name('Show_Patient_List');
	Route::get('/Show_Medical_Instruction/{clinic_id}','Phermacy\PatientTaskController@Show_Medical_Instruction')->name('Show_Medical_Instruction');
	Route::get('Finish_Patient/{clinic_id}','Phermacy\PatientTaskController@Finish_Patient')->name('Finish_Patient');

});

/* Route Accessible By Laboatorist */
Route::prefix('Labratory')->name('Labratory.')->middleware('Labratory')->group(function(){
	Route::get('{id}/LogOut','Labratory\LogOutController@LogOut')->name('LogOut');
	Route::get('{id}/Profile','Labratory\ProfileController@ShowProfile')->name('Profile');
	Route::get('/SelectRoom','Common\RoomController@SelectRoom')->name('SelectRoom');
	Route::get('/Show_Patient_List','Labratory\PatientTaskController@Show_Patient_List')->name('Show_Patient_List');
	Route::get('{username}/Show_Patient_Data/{clinic_id}','Labratory\PatientTaskController@Show_Patient_Data')->name('Show_Patient_Data');
	Route::get('{username}/Finish/{clinic_id}','Labratory\PatientTaskController@Finish')->name('Finish');
	Route::get('{username}/Add_Patient_Result/{clinic_id}','Labratory\PatientTaskController@Add_Patient_Result')->name('Add_Patient_Result');
	Route::get('/{username}/Submit_Result/{clinic_id}','Labratory\PatientTaskController@Submit_Result')->name('Submit_Result');

});

app/Labratory.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Foundation\Auth\Labratory as Authenticatable;

class Labratory extends Authenticatable
{
    public $table='Labratory';
    protected $keyType='char';
    public $incrementing=false;
    protected $primaryKey='username';
    protected $hidden=[
    'username','password','remember_token'
    ];

    protected $fillable=[
    'full_name','username','email','password','age','sex','graduated_college_university','photo','graduated_area','Graduated_status'
    ];
}

app/Http/Controllers/Labratory/Labratory_PatientInfo.php
<?php

namespace App\Http\Controllers\Labratory;

use Illuminate\Support\Facades\Auth;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use App\Servants\Daily_Servant;
use Illuminate\Support\Carbon;
use App\CommonModel\Daily_labratory;
use App\room;
class Labratory_PatientInfo extends Controller
{  
    public static function Patient_Number(){
    	$username=Auth::guard("Labratory")->user()->username;
    	$user_data=Daily_Servant::where('servant_id',$username)->latest()->first();
    	$user_room=$user_data->daily_room;
    	$Patient_Number=Daily_labratory::where('Labratory_room',$user_room)->whereDate('created_at',Carbon::today())->whereNull('labratorist_mark')->whereNotNull('ins_fr_do_lab')->count();
    	return $Patient_Number;


    }

    public static function Show_Labratory_Patient_List(){
    	$username=Auth::guard("Labratory")->user()->username;
    	$user_data=Daily_Servant::where('servant_id',$username)->latest()->first();
    	$user_room=$user_data->daily_room;

    	$Patient_List=room::find($user_room)->Labratory_Patient_List()->whereDate('daily_labratory.created_at',Carbon::today())->whereNull('daily_labratory.labratorist_mark')->whereNotNull('daily_labratory.ins_fr_do_lab')->orderBy('daily_labratory.id','asc')->where('daily_labratory.labratory_room',$user_room)->paginate(2);

    	return $Patient_List;

    }
}

app/Http/Controllers/Labratory/LogOutController.php
<?php

namespace App\Http\Controllers\Labratory;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\Auth;
use App\Labratory;

class LogOutController extends Controller
{
    public function LogOut(){
    	$username=Auth::guard("Labratory")->user()->username;
        $user_data=Labratory::find($username);
        $user_data->active=0;
        $user_data->save();
        Auth::guard('Labratory')->LogOut();
    	return redirect('/')->with('Success','Sign Out Successfully');
    }
}

app/Http/Controllers/Labratory/PatientTaskController.php
<?php

namespace App\Http\Controllers\Labratory;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use App\Http\Controllers\Labratory\Labratory_PatientInfo;
use App\CommonModel\Daily_labratory;
use Illuminate\Support\Carbon;

class PatientTaskController extends Controller
{   
    

    public function Show_Patient_List(){
    	$patient_number=Labratory_PatientInfo::Patient_Number();
        $Patient_List=Labratory_PatientInfo::Show_Labratory_Patient_List();
        return view('Labratory.Show_Labratory_Patient_List',['patient_number'=>$patient_number,'Patient_List'=>$Patient_List]);
    }



    public function Show_Patient_Data($labratorist_id,$clinic_id){
       $patient_number=Labratory_PatientInfo::Patient_Number();
       $show_data=Daily_labratory::where('clinic_id',$clinic_id)->latest()->first();
       return view('Labratory.Show_Patient_Data',['show_data'=>$show_data,'patient_number'=>$patient_number]);


    }


    public function Finish($Labratory_id,$clinic_id){
    	$mark=Daily_labratory::where('clinic_id',$clinic_id)->latest()->first();
    	$mark->labratorist_mark=1;
    	$mark->labratorist_id=$Labratory_id;
    	$save=$mark->save();

    	if ($save) {
    		return redirect()->route('Labratory.Show_Patient_List')->with('message_success','Patient Finish Task In This Room');
    	}

    	else{
    		return redirect()->route('Labratory.Show_Patient_List')->with('message_warning','There Is Database Error');
    	}

    }

    public function Add_Patient_Result($Labratorist_id,$clinic_id){
    	$patient_number=Labratory_PatientInfo::Patient_Number();
        return view('Labratory.Add_Patient_Result',['Labratorist_id'=>$Labratorist_id,'clinic_id'=>$clinic_id,'patient_number'=>$patient_number]);

    }



    public function Submit_Result(request $request,$Labratorist_id,$clinic_id){

        
        $request->validate(['result'=>'required']);
    	$save=Daily_labratory::where('clinic_id',$clinic_id)->whereDate('created_at',Carbon::today())->whereNULL('labratorist_mark')->update(['labratorist_id'=>$Labratorist_id,'resp_fr_lab_to_doc'=>$request['result']]);
        
    	

    	if ($save) {
    		return redirect()->route('Labratory.Show_Patient_List')->with('message_success','Result Added Successfully');
    	}

    	else
    	{
    	 	return redirect()->route('Labratory.Show_Patient_List')->with('message_warning','Database Error');
    	}


    }
}

app/Http/Controllers/Labratory/ProfileController.php
<?php

namespace App\Http\Controllers\Labratory;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;

class ProfileController extends Controller
{
    public function ShowProfile(){
    	return view('Labratory.Profile');
    }
}

resources/views/Labratory/Add_Patient_Result.blade.php
@extends('Labratory.Home')
@section('Sub_Content')
@parent
<div class="container mt-3">
	<div class="row">
		<div class="col-md-6">
			<div class="card card-block">
				<div class="card-header text-info text-center">Labratorist Response Paper</div>
				<div class="card-body">
					<div class="form-group">
						<form method="GET" action="{{route('Labratory.Submit_Result',['Labratorist_id'=>$Labratorist_id,'clinic_id'=>$clinic_id])}}">
							<label for="Labratorist">Write Labratory Result</label>
							<textarea  id="Labratorist" name="result" class="form-control"></textarea><br>
							<button class="btn btn-success" type="submit">Add</button>
						</form>
					</div><br>
                    
				</div>
			</div>
		</div>
	</div>
</div>
@endsection

resources/views/Labratory/Home.blade.php
@extends('ClinicLayout.Main')
@section('tittle','Labratory')
@section('content')
<div class="container-fluid">
	@section('Sub_Content')
	<nav class="navbar navbar-expand-lg navbar-light bg-light">
  <a class="navbar-brand" href="#">Astu Cms</a>
  <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
    <span class="navbar-toggler-icon"></span>
  </button>

  <div class="collapse navbar-collapse" id="navbarSupportedContent">
    <ul class="navbar-nav mr-auto">
      <li class="nav-item active">
        <a class="nav-link" href="#">Home<span class="sr-only">(current)</span></a>
      </li>
      <li class="nav-item">
        <a href="{{route('Labratory.Show_Patient_List')}}" class="nav-link" role="button"  tabindex="-1">TodayPatient<span class="badge badge-pill badge-light" style="float: right;">{{$patient_number}}</span></a>
      </li>
      
      <li class="nav-item">
        <a class="nav-link disabled" href="#" tabindex="-1" aria-disabled="true">Disabled</a>
      </li>
    </ul>
    <form class="form-inline mr-auto">
      <input class="form-control mr-sm-2" type="search" placeholder="Search" aria-label="Search">
      <button class="btn btn-outline-success my-2 my-sm-0" type="submit">Search</button>
    </form>
    <div class="mr-5 dropdown">
    	<a class="nav-link dropdown-toggle" href="#" id="navbarDropdown" role="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false"><span> {{Auth::guard('Labratory')->user()->username}}</span>
          <i class="fas fa-user"></i>
    	
        </a>
        <div class="dropdown-menu" aria-labelledby="navbarDropdown">
          <a class="dropdown-item" href="{{route('Labratory.LogOut',['id'=>Auth::guard('Labratory')->user()->username])}}">LogOut</a>
          <a class="dropdown-item" href="{{route('Labratory.Profile',['id'=>Auth::guard('Labratory')->user()->username])}}">Profile</a>
    </div>
  </div>
</nav>
@show
</div>
@endsection

resources/views/Labratory/Profile.blade.php
@extends('Labratory.Home')
@section('Sub_Content')
@parent
<div class="container">
	<div class="row">
		<div class="col-md-8 col-sm-12">
			<div class="card">
				<div class="card-header text-center">
					Profile
				</div>
				<div class="card-body">
					<img src="{{asset(Auth::guard('Labratory')->user()->photo)}}" class="rounded-circle card-img-top " style="width: 40%; height: 40%;" alt="user photo">

					<ul class="list-group list-unstyled">
						<li class="list-group-item"><b>Full Name</b><span class="badge" style="float: right;">{{Auth::guard('Labratory')->user()->full_name}}</span></li>

						<li class="list-group-item"><b>E-mail</b><span class="badge" style="float: right;">{{Auth::guard('Labratory')->user()->email}}</span></li>

						<li class="list-group-item"><b>Username</b><span class="badge" style="float: right;">{{Auth::guard('Labratory')->user()->username}}</span></li>
						
						<li class="list-group-item"><b>Graduated_in</b><span class="badge" style="float: right;">{{Auth::guard('Labratory')->user()->graduated_college_university}}</span></li>

						<li class="list-group-item"><b>Area of Studies</b><span class="badge" style="float: right;">{{Auth::guard('Labratory')->user()->graduated_area}}</span></li>

						<li class="list-group-item"><b>sex</b><span class="badge" style="float: right;">{{Auth::guard('Labratory')->user()->sex}}</span></li>

						<li class="list-group-item"><b>Age</b><span class="badge" style="float: right;">{{Auth::guard('Labratory')->user()->age}}</span></li>

						<li class="list-group-item"><b>graduated_status</b><span class="badge">{{Auth::guard('Labratory')->user()->graduated_status}}</span></li>
					</ul>
				</div>	
			</div>
		</div>
	</div>
@endsection

resources/views/Labratory/SelectRoom.blade.php
@extends('ClinicLayout.Main')
@section('tittle','Select_Room')
@section('content')
<div class="container" style="margin-top: 5%;">
	<div class="row">
		<div class="col-md-3">
			<div class="card">
				<div class="card-body">
					<div class="card-block">
						<div class="form-group">
							<form method="GET" action="{{route('Labratory.SelectRoom')}}">
								<label for="room_name">Select Room</label>
								<select class="form-control" id="room_name" name="room">
									@foreach($room as $single)
									<option>{{$single->room_name}}</option>
									@endforeach
								</select><br>
								<button class="btn btn-primary" type="submit">Submit</button>
							</form>
						</div>
					</div>
				</div>
			</div>
		</div>
	</div>
</div>
@endsection

resources/views/Labratory/Show_Labratory_Patient_List.blade.php
@extends('Labratory.Home')
@section('Sub_Content')
@parent
<div class="container">
	<div class="row">
		<div class="col-md-9 mt-1">
			@if(Session::has('message_success'))
			 <div class="alert alert-success bg-success text-white">
			 	{{Session::get('message_success')}}
			 </div>
			 @elseif(Session::has('message_warning'))
			  <div class="alert alert-warning bg-warning">
			 	{{Session::get('message_warning')}}
			 </div>
			@endif
			@if(count($Patient_List)>0)
			<div class="list-group list-unstyled">
				@foreach($Patient_List as $Patient)
				 <div class="list-group-item m-1">
				 	{{$Patient->first_name." ".$Patient->last_name." ".$Patient->grand_name}}
				 	<a href="{{route('Labratory.Show_Patient_Data',['username'=>Auth::guard("Labratory")->user()->username,'clinic_id'=>$Patient->clinic_id])}}" class="btn btn-success  float-right" >See</a>
				 </div>
				@endforeach
			</div><br>
             {{$Patient_List->links()}}
			@else
			NO Patient Know !!
			@endif
		</div>
	</div>
</div>
@endsection

resources/views/Labratory/Show_Patient_Data.blade.php
@extends('Labratory.Home')
@section('Sub_Content')
@parent
<div class="container mt-2">
	<div class="row offset-md-2">
		<div class="col-md-8">
			<div class="card card-block" style="width: 20rem;">
			<div class="card-header text-info text-center">
				Labratory Instruction
			</div>
			<div class="card-body">
				<div class="card-info">
					{{$show_data->ins_fr_do_lab}}
				</div>
			</div>
			<div class="card-footer">
				Send By{{ "  ".App\Doctors::find($show_data->doctor_id)->full_name}} on {{"  ".$show_data->created_at}}
			</div>
		</div><br>
		<a href="{{route('Labratory.Add_Patient_Result',['username'=>Auth::guard('Labratory')->user()->username,'clinic_id'=>$show_data->clinic_id])}}">Add Your Result</a><br>

        <a href="{{route('Labratory.Finish',['username'=>Auth::guard('Labratory')->user()->username,'clinic_id'=>$show_data->clinic_id])}}">finish</a>
		</div>
		
	</div>
</div>
@endsection